//Grille.cc

#include "Grille.h"

Grille::Grille()
{
  string pb;
  for (short x=0; x<16; x++)
    for (short y=0; y<16; y++) table[x][y]=INCONNU;
  for (int cpt=0; cpt<11; cpt++) bateaux[cpt]=NULL;
  affiche("Exemple: 'B5 v' pour debut en B5 et vertical");
  /*newBateau(0,5); //1 porte-avion
  affiche(toStringPerso());*/
  newBateau(1,4); //2 sous-marins
  affiche(toStringPerso());
  /*newBateau(2,4);
  affiche(toStringPerso());
  newBateau(3,3); //4 cuirasss
  affiche(toStringPerso());
  newBateau(4,3);
  affiche(toStringPerso());
  newBateau(5,3);
  affiche(toStringPerso());
  newBateau(6,3);
  affiche(toStringPerso());
  newBateau(7,2); //4 pneumatiques
  affiche(toStringPerso());
  newBateau(8,2);
  affiche(toStringPerso());
  newBateau(9,2);
  affiche(toStringPerso());*/
  newBateau(10,2);
  affiche(toStringPerso());
  affiche("Fin placement des bateaux");
}

Grille::~Grille()
{
  for (int cpt=0; cpt<11; cpt++)
    if (bateaux[cpt]!=NULL) delete bateaux[cpt];
}

void Grille::newBateau(short num, short modele)
{
  char declaration[10];
  affiche("Saisir "+Bateau::toString(modele));
  cin.getline(declaration,10,'\n');
  short x = declaration[0]-64;
  string tmp = strPrefixe(charToStr(declaration),1,' ');
  short y = atoi(strToChar(tmp));
  tmp = strPrefixe(charToStr(declaration),tmp.length()+2,'\0');
  bool vert = ((tmp=="v") || (tmp=="V"));
  if ((vert && ((y+modele-1)>16)) || (!vert && ((x+modele-1)>16)))
  {
    affiche("Le bateau ne rentre pas  l'enplacement spcifi");
    newBateau(num,modele);
  }
  else
  {
    int cpt=0;
    bool ok=true;
    //vrification de l'intersection avec aucun autre bateau
    while (ok && (cpt<11))
    {
      if ((bateaux[cpt]!=NULL)&&(cpt!=num))
        if (vert)
          for (int cpt2=y; cpt2<(y+modele); cpt2++) ok=ok&&(!bateaux[cpt]->isDedans(x,cpt2));
        else
          for (int cpt2=x; cpt2<(x+modele); cpt2++) ok=ok&&(!bateaux[cpt]->isDedans(cpt2,y));
      cpt++;
    }
    if (ok) bateaux[num] = new Bateau(x,y,vert,modele);
    else
    {
      affiche("Collision avec un autre bateau");
      newBateau(num,modele);
    }
  }
}

string Grille::bombarde(short x, short y)
{
  bool trouve=false;
  short cpt=0;
  if (table[x-1][y-1]==INCONNU)
  {
    while (!trouve && (cpt<11))
    {
      if (bateaux[cpt]!=NULL) trouve = bateaux[cpt]->isDedans(x,y);
      cpt++;
    }
    if (trouve)
    {
      cpt--;
      switch (bateaux[cpt]->bombarde())
      {
        case TOUCHE:
        {
          table[x-1][y-1]=TOUCHE;
          return numToAlpha(x)+intToStr(y)+" Touch";
          break;
        }
        case COULE:
        {
          int i;
          if (bateaux[cpt]->isVertical())
            for (i=bateaux[cpt]->getY(); i<(bateaux[cpt]->getY()+bateaux[cpt]->getType()); i++) table[x-1][i-1]=COULE;
          else
            for (i=bateaux[cpt]->getX(); i<(bateaux[cpt]->getX()+bateaux[cpt]->getType()); i++) table[i-1][y-1]=COULE;
          bool toutCoule=true;
          i=0;
          while (toutCoule && (i<11))
          {
            if (bateaux[i]!=NULL) toutCoule = bateaux[i]->isCoule();
            i++;
          }
          string reponse;
          if (toutCoule) reponse=numToAlpha(x)+intToStr(y)+" Flotte dtruite :  Coul "+bateaux[cpt]->toString();
          else reponse = numToAlpha(x)+intToStr(y)+" Coul "+bateaux[cpt]->toString();
          return reponse;
          break;
        }
        default: return "erreur";
      }
    }
    else
    {
      table[x-1][y-1]=EAU;
      return numToAlpha(x)+intToStr(y)+" Dans l'eau";
    }
  }
  else return numToAlpha(x)+intToStr(y)+" Case dj dcouverte";
}

void Grille::affiche(string texte)
{
  cout<<texte<<endl;
}

string Grille::toString()
{
  return toString(table);
}

string Grille::toStringPerso()
{
  short table_temp[16][16];
  for (short x=0; x<16; x++)
    for (short y=0; y<16; y++) table_temp[x][y]=table[x][y];
  for (short cpt=0; cpt<11; cpt++)
    if (bateaux[cpt]!=NULL)
      if (bateaux[cpt]->isVertical())
      {
        short x=bateaux[cpt]->getX();
        for (short y=bateaux[cpt]->getY(); y<(bateaux[cpt]->getY()+bateaux[cpt]->getType()); y++)
          if (table_temp[x-1][y-1]==INCONNU) table_temp[x-1][y-1]=bateaux[cpt]->getType();
      }
      else
      {
        short y=bateaux[cpt]->getY();
        for (short x=bateaux[cpt]->getX(); x<(bateaux[cpt]->getX()+bateaux[cpt]->getType()); x++)
          if (table_temp[x-1][y-1]==INCONNU) table_temp[x-1][y-1]=bateaux[cpt]->getType();
      }
  return toString(table_temp);
}

string Grille::toString(short uneTable[16][16])
{
  string temp="    ";
  for (short x=1; x<=16; x++) temp+=numToAlpha(x)+"  ";
  temp+="\n";
  for (short y=0; y<16; y++)
  {
    temp+=intToStr(y+1,2)+"- ";
    for (short x=0; x<16; x++) temp+=intToStr(uneTable[x][y])+"  ";
    temp+="\n";
  }
  return temp;
}
