//Joueur.cc

#include "Joueur.h"
#include "utilitaires.h"
#include "sock.h"

#include <sys/time.h>
#include <iostream.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>       //pour la fct sprintf
#include <sys/stat.h>
#include <fcntl.h>


Joueur::Joueur()
{
  Sock maBr(SOCK_STREAM, short(24119)); //Boite Reseau locale
  desc = maBr.getsDesc(); //Descripteur
  desc_console = 0; //entre standard
  descchat = 0;
  descgrille = 0;
  locale = 0;
  grille = NULL;
  //pret = false;
  enCours = false;
  ouvrirConnection();
}

Joueur::~Joueur()
{
  if (grille!=NULL) delete grille;
  delete(BrDist);
  close(desc);
  fermeDescFen();
}

void Joueur::ouvreDescFen()
{
  char * fenchat=lireAdresse("saisir l'adresse de la fenetre destin au chat");
  char * fengrille=lireAdresse("saisir l'adresse de la fenetre destin aux grilles");

  descchat=open(fenchat, O_WRONLY);
  if (descchat<0)
  {
    perror("pb erreur ouverture desc sur fenetre de chat");
    descchat=0;
  }

  descgrille=open(fengrille,O_WRONLY);
  if (descgrille<0)
  {
    perror("pb erreur ouverture desc sur fenetre de grille");
    descgrille=0;
  }
  affiche("",descgrille);
  affiche("",descchat);
}

void Joueur::fermeDescFen()
{
 if (descchat!=0) close(descchat);
 if (descgrille!=0) close(descgrille);
}

void Joueur::ouvrirConnection()
{
  //Connection  la boite publique du serveur
  BrDist = new SockDist(lireAdresse("Veuillez saisir l'adresse du serveur : "), short(24118));  //Boite Reseau distante
  sockaddr_in* adrDist = BrDist->getAdrDist();  //La socket distante
  int connection = connect(desc, (sockaddr*)adrDist,sizeof(sockaddr));
  ok=true;
  if (connection==-1)
  {
    ok=false;
    affiche("Erreur de connection");
  }
  else affiche("Connect  Bataille");
}

void Joueur::envoyer(string texte)
{
  int envoie = send(desc, strToChar(texte),texte.length()+1, 0);
  if (envoie<=0) affiche("Erreur envoi");
}

char * Joueur::lireAdresse(string texte)
{
  affiche(texte,locale);
  string buff;
  cin>>buff;
  if (buff.length()<3) return lireAdresse(texte);
  else return strToChar(buff);
}

void Joueur::traiteSocket()
{
  int reception = recv(desc, &tamponrcp, sizeof(tamponrcp), 0);
  if (reception<=0)
  {
    affiche("Erreur de rception");
    ok=false;
  }
  else if (strncmp(tamponrcp,"resultat",8)==0)
  {
    string corps = strPrefixe(charToStr(tamponrcp),9,'\0');
    corps = strReplace(corps,'_','\n');
    affiche("resultat "+corps);
  }
  else if (strncmp(tamponrcp,"grilres",7)==0)
  {
    string nom = strPrefixe(charToStr(tamponrcp),8,' ');
    string corps = strPrefixe(charToStr(tamponrcp),8+nom.length()+1,'\0');
    corps = strReplace(corps,'_','\n');
    affiche("Grille de "+nom,descgrille);
    affiche(corps,descgrille);
  }
  else if (strncmp(tamponrcp,"grille",6)==0)
  {
    string nom = strPrefixe(charToStr(tamponrcp),7,' ');
    string temp = grille->toString();
    temp = strReplace(temp,'\n','_');
    envoyer("grilres "+nom+" "+temp);
  }
  else if (strncmp(tamponrcp,"bombe",5)==0)
  {
    //affiche(tamponrcp);
    string attaque = strPrefixe(charToStr(tamponrcp),6,' ');
    int x=alphaToNum(tamponrcp[6+attaque.length()+1]);
    int y=atoi(strToChar(strPrefixe(charToStr(tamponrcp),6+attaque.length()+2,'\0')));
    string la_reponse =grille->bombarde(x,y);
    envoyer("resultat "+attaque+" "+la_reponse);
    affiche("bombe "+attaque+" en "+strPrefixe(charToStr(tamponrcp),6+attaque.length()+1,'\0')+" : "+la_reponse);
  }
  else if (strncmp(tamponrcp,"debut",5)==0)
  {
    affiche(tamponrcp);
    enCours=true;
  }
  else if (strncmp(tamponrcp,"fin",3)==0)
  {
    string corps;
    if (strlen(tamponrcp)>3) corps= strPrefixe(charToStr(tamponrcp),4,' ');
    affiche("La partie est finie "+corps);
    enCours=false;
  }
  else if ((tamponrcp[0]=='0')||(strlen(tamponrcp)<2))
  {
    affiche("le serveur a t arrt");
    ok=false;
  }
  else affiche(tamponrcp);

}

void Joueur::traiteClavier()
{
  cin.getline(tamponenv,256,'\n');
  if (strncmp(tamponenv,"grille",6)==0)
  {
    string nom = strPrefixe(charToStr(tamponenv),7,' ');
    if (nom=="moi") affiche(grille->toStringPerso(),descgrille);
    else envoyer("grille "+nom);
  }
  else if (strncmp(tamponenv,"fenetre",7)==0)
  {
    fermeDescFen();
    ouvreDescFen();
  }
  else if (strncmp(tamponenv,"nouveau",7)==0)
  {
    if (!enCours)
    {
      if (grille!=NULL) delete grille;
      grille = new Grille();
      envoyer("pret");
    }
    else affiche("La partie est en cours");
  }
  else if (strncmp(tamponenv,"aide",4)==0)
  {
    affiche("Liste des commandes : \n");
    affiche("bombe <nom> <texte>");
    affiche("grille <nom>");
    affiche("INCONNU = "+intToStr(INCONNU)+" BATEAU = "+intToStr(BATEAU)+" TOUCHE = "+intToStr(TOUCHE)+" COULE = "+intToStr(COULE)+" EAU = "+intToStr(EAU));
    affiche("PORTE_AVION = "+intToStr(PORTE_AVION)+" SOUS_MARIN = "+intToStr(SOUS_MARIN)+" CUIRASSE = "+intToStr(CUIRASSE)+" PNEUMATIQUE = "+intToStr(PNEUMATIQUE));
    affiche("chat <nom> <texte>");
    affiche("nom <nouveau nom>");
    affiche("nouveau");
    affiche("isPret (pour Matre de jeu)");
    affiche("debut (pour Matre de jeu)");
    affiche("dir");
    affiche("moi");
    affiche("fenetre");
    affiche("aide");
    affiche("");
  }
  else if (tamponenv[0]=='0') //le client s'arrte
  {
    ok=false;
    envoyer("0");
  }
  else if (strlen(tamponenv)>0) envoyer(charToStr(tamponenv));
}

void Joueur::demarre()
{
  fd_set table_desc_read;
  fd_set table_desc_except;

  while (ok)
  {
    //Initialisation de la sauvegarde du systme SELECT
    FD_ZERO(&table_desc_read);
    FD_ZERO(&table_desc_except);
    FD_SET(desc_console,&table_desc_read);
    FD_SET(desc,&table_desc_read);
    FD_SET(desc_console,&table_desc_except);
    FD_SET(desc,&table_desc_except);

    select(desc+1,&table_desc_read,NULL,&table_desc_except,NULL); //bloquant

    if (FD_ISSET(desc,&table_desc_read)) traiteSocket();
    else if (FD_ISSET(desc_console,&table_desc_read)) traiteClavier();
    else if (FD_ISSET(desc,&table_desc_except))
    {
      ok=false;
      affiche("Exception rseau");
    }
    else if (FD_ISSET(desc_console,&table_desc_except))
    {
      ok=false;
      affiche("Erreur d'entre au clavier");
    }
  }
}

void Joueur::affiche(string texte)
{
  //cout<<texte<<endl;
  affiche(texte,descchat);
}

void Joueur::affiche(string texte,int descadresse)
{
  if (descadresse==locale) cout<<texte<<endl;
  else
  {
    texte+="\n";
    char* tampon=strToChar(texte);
    int ecritext=write(descadresse,tampon,texte.length());
  }
}

void Joueur::affiche(char * texte)
{
  affiche(charToStr(texte));
}
