//serveurPrive.cc

#include "ServeurPrive.h"
#include "ServeurPublic.h" //suite de la dclaration avance
#include "utilitaires.h"

#include <stdio.h>
#include <sys/socket.h>

ServeurPrive::ServeurPrive(int numdesc, bool administ, ServeurPublic * pere)
{
  num_desc=numdesc;
  nomJoueur="joueur"+intToStr(num_desc);
  serveurPublic=pere;
  administrateur=administ;
  pret = false;
  aJoue = false;
}

ServeurPrive::~ServeurPrive()
{
  close(num_desc); //ferme le descripteur
}

void ServeurPrive::destroy(bool envoiMessage)
{
  affiche("Destruction du serveur priv");
  if (envoiMessage) envoyerMessage("0");
  delete this;
}

void ServeurPrive::arrete(string texte)
{
  affiche(texte);
  if (pret) serveurPublic->decJoueursPrets();
  serveurPublic->supprimeClient(num_desc, false);
}

void ServeurPrive::envoyerMessage(string texte)
{
  int envoie = send(num_desc,strToChar(texte),texte.length()+1,0);
  if (envoie==-1) arrete("Erreur d'envoi");
  else affiche("-> "+texte);
}

void ServeurPrive::envoyerMessage(char * texte)
{
  envoyerMessage(charToStr(texte));
}

void ServeurPrive::traiterMessage(char * texte)
{
  affiche("<- "+charToStr(texte));

  if ((strncmp(texte,"bombe",5)==0)&&serveurPublic->getEnCours()&&pret) //envoit d'un message d'attaque
  {
    if (!aJoue)
    {
      string nom = strPrefixe(texte,6,' ');
      string corps = strPrefixe(texte,6+nom.length()+1,'\0');
      ServeurPrive * destinataire = serveurPublic->envoyerAJoueur(nom,"bombe "+nomJoueur+" "+corps);
      if ((destinataire!=NULL) && (destinataire->isPret())) aJoue = true;
      else envoyerMessage("Le joueur "+nom+" n'est pas pret. Jouez encore.");
    }
    else envoyerMessage("Vous avez dj jou ce tour ci");
  }
  else if ((strncmp(texte,"grille",6)==0)&&serveurPublic->getEnCours()) //envoit d'un message de grille
  {
      string nom = strPrefixe(texte,7,' ');
      string corps = strPrefixe(texte,7+nom.length()+1,'\0');
      serveurPublic->envoyerAJoueur(nom,"grille "+nomJoueur+" "+corps);
  }
  else if (strncmp(texte,"grilres",7)==0) //envoit d'un message de grille
  {
    string nom = strPrefixe(texte,8,' ');
    if (serveurPublic->getEnCours()&&pret)
    {
      string corps = strPrefixe(texte,8+nom.length()+1,'\0');
      serveurPublic->envoyerAJoueur(nom,"grilres "+nomJoueur+" "+corps);
    }
    else serveurPublic->envoyerAJoueur(nom,"grilres "+nomJoueur+": Le joueur n'est pas prt");
  }
  else if ((strncmp(texte,"resultat",8)==0)&&serveurPublic->getEnCours()&&pret) //envoit d'un message de reponse
  {
    string nom = strPrefixe(texte,9,' ');
    string corps = strPrefixe(texte,9+nom.length()+1,'\0');
    string coordonnees = strPrefixe(corps,0,' ');
    int x = alphaToNum(coordonnees[0]);
    int y = atoi(strToChar(strPrefixe(coordonnees,1,' ')));
    string resul = strPrefixe(corps,coordonnees.length()+1,' ');
    string bateauTouch="";
    if ((coordonnees.length()+resul.length()+2)<corps.length()) bateauTouch = strPrefixe(corps,coordonnees.length()+resul.length()+2,' ');

    short action = 0;
    if (strncmp(strToChar(resul),"Dans",4)==0) action=EAU;
    else if (strncmp(strToChar(resul),"Touch",6)==0) action=TOUCHE;
    else if (strncmp(strToChar(resul),"Coul",5)==0) action=COULE;
    else if (strncmp(strToChar(resul),"Flotte",6)==0)
    {
      action=FLOTTE;
      pret=false;
      serveurPublic->decJoueursPrets();
      affiche("Hors-jeu");
    }
    //serveurPublic->envoyerAJoueur(nom,"resultat "+nomJoueur+" "+corps);
    casesJouees[x][y].bombe(nom,action,bateauTouch);
    serveurPublic->incOntJoues();
  }
  else if (strncmp(texte,"chat",4)==0) //envoit d'un message Chat
  {
    string nom = strPrefixe(texte,5,' ');
    string corps = strPrefixe(texte,5+nom.length()+1,'\0');
    if (nom=="tous") serveurPublic->envoyerATous(nomJoueur+">"+corps);
    else serveurPublic->envoyerAJoueur(nom,nomJoueur+">"+corps);
  }
  else if (strncmp(texte,"dir",3)==0) //retourne la liste des joueurs
  {
    string temp = serveurPublic->getListeJoueurs();
    strcpy(tamponenv,strToChar(temp));
    envoyerMessage(temp);
  }
  else if ((strncmp(texte,"debut",5)==0)&&pret) //rception du nom joueur
  {
    if (administrateur)
    {
      serveurPublic->setEnCours(true);
      serveurPublic->envoyerATous("debut de la partie (Matre de jeu "+nomJoueur+")");
    }
    else envoyerMessage("Vous n'tes pas matre de jeu");
  }
  else if ((strncmp(texte,"pret",4)==0)&&!serveurPublic->getEnCours()) //le joueur est pret
  {
    affiche("est prt");
    if (!pret) serveurPublic->incJoueursPrets();
    pret=true;
    aJoue=false;
  }
  else if (strncmp(texte,"isPret",6)==0) //le joueur est pret
  {
    if (administrateur)
    {
      serveurPublic->envoyerATous("Le matre de jeu s'apprte  dmarrer la partie");
      envoyerMessage(serveurPublic->getJoueursPrets());
    }
    else envoyerMessage("Vous n'tes pas matre de jeu");
  }
  else if (strncmp(texte,"moi",3)==0) //le joueur est pret
  {
    envoyerMessage("votre nom est: "+nomJoueur);
  }
  else if ((strncmp(texte,"nom",3)==0)&&!serveurPublic->getEnCours()) //rception du nom joueur
  {
    string nom = strPrefixe(texte,4,'\0');
    if (nom.length()>2)
    {
      if (serveurPublic->getJoueur(nom)==NULL)
      {
        affiche("nouveau nom: "+nom);
        nomJoueur=nom;
      }
      else envoyerMessage("Ce nom est dj utilis");
    }
    else  envoyerMessage("Nom invalide");
  }
  else if (strcmp(texte,"0")==0) arrete("Dsistement");
  else envoyerMessage("Commande inattendue :"+charToStr(texte)); //message pas trait
}

void ServeurPrive::messageRecu()
{
  int reception = recv(num_desc,&tamponrcp,sizeof(tamponrcp),0);
  if (reception<=0) arrete("mauvaise rception");
  else traiterMessage(tamponrcp);
}

void ServeurPrive::exceptionRecue()
{
  arrete("connection casse");
}

string ServeurPrive::getNomJoueur()
{
  return nomJoueur;
}

bool ServeurPrive::isPret()
{
  return pret;
}

bool ServeurPrive::isAJoue()
{
  return aJoue;
}

void ServeurPrive::resetAJoue()
{
  aJoue=false;
}

void ServeurPrive::resetCasesJouees()
{
  for (int x=0;x<16;x++)
    for (int y=0;y<16;y++) casesJouees[x][y].reset();
}

string ServeurPrive::getCasesJouees()
{
  string Result="";
  for (int x=0;x<16;x++)
    for (int y=0;y<16;y++)
      if (casesJouees[x][y].isSet()) Result+=casesJouees[x][y].toString()+" en "+numToAlpha(x)+intToStr(y)+"_";
  if (Result[Result.length()-1]!='_') Result+="_";
  resetCasesJouees();
  return "resultat "+nomJoueur+":   "+Result;
}

void ServeurPrive::affiche(string texte)
{
  cout<<nomJoueur<<"@serveur"<<num_desc<<" "<<texte<<endl;
}
