//ServeurPublic.cc

#include "ServeurPublic.h"
#include "ServeurPrive.h" //suite de la dclaration avance
#include "sock.h"
#include "utilitaires.h"

#include <iostream.h>
#include <stdio.h>       //pour la fct sprintf

ServeurPublic::ServeurPublic()
{
  tailleCV = sizeof(adCV);
  nbClients=0;
  joueursPrets=0;
  enCours=false;
  ok=true;
  for (int cpt=0; cpt<255; cpt++) table_num_serveurs[cpt]=0;
  demarre();
}

ServeurPublic::~ServeurPublic()
{
  arrete("destructeur");
  close(desc_public);
}

void ServeurPublic::arrete(string texte)
{
  affiche(texte+" ("+intToStr(nbClients)+")");
  for (int cpt=0; cpt<nbClients; cpt++) table_serveurs[table_num_serveurs[cpt]]->destroy(true);
  nbClients=0;
  ok=false;
}

void ServeurPublic::nouveauClient(int numClient)
{
  table_serveurs[numClient]=new ServeurPrive(numClient,(nbClients<=0),this);
  FD_SET(numClient,&table_desc_backup);
  table_num_serveurs[nbClients]=numClient;
  nbClients++;
  mini = numClient<mini ? numClient : mini;
  maxi = numClient>mini ? numClient : maxi;
  affiche("Il y a "+intToStr(nbClients)+" clients");
}

void ServeurPublic::supprimeClient(int numClient, bool envoiMessage)
{
  string nomJoueur = table_serveurs[numClient]->getNomJoueur();
  table_serveurs[numClient]->destroy(envoiMessage);
  FD_CLR(numClient,&table_desc_backup);
  int cpt=0;
  while ((table_num_serveurs[cpt]!=numClient)&&(cpt<256)) cpt++;
  nbClients--;
  for (int i=cpt; i<nbClients; i++) table_num_serveurs[cpt]=table_num_serveurs[cpt+1];
  ok=(nbClients>0);
  envoyerATous("sortie "+nomJoueur);
  affiche("Il y a "+intToStr(nbClients)+" client(s)");
}

ServeurPrive * ServeurPublic::envoyerAJoueur(string nom, string texte)
{
  ServeurPrive * monJoueur = getJoueur(nom);
  if (monJoueur!=NULL)
  {
    monJoueur->envoyerMessage(strToChar(texte));
    return monJoueur;
  }
  else
  {
    affiche("Joueur "+nom+" inconnu");
    return NULL;
  }
}

void ServeurPublic::envoyerATous(string texte)
{
  affiche("-> "+texte);
  for (int cpt=0; cpt<nbClients; cpt++) table_serveurs[table_num_serveurs[cpt]]->envoyerMessage(texte);
}

void ServeurPublic::affiche(char * texte)
{
  affiche(charToStr(texte));
}

void ServeurPublic::affiche(string texte)
{
  cout<<"  ServeurPublic "<<texte<<endl;
}

string ServeurPublic::getJoueursPrets()
{
  int nbPrets=0;
  for (int cpt=0; cpt<nbClients; cpt++)
    if (table_serveurs[table_num_serveurs[cpt]]->isPret()) nbPrets++;
  joueursPrets=nbPrets;
  return "Il y a "+intToStr(nbPrets)+" joueur(s) prts sur "+intToStr(nbClients);
}

ServeurPrive * ServeurPublic::getJoueur(string nom)
{
  bool trouve=false;
  int cpt=0;
  while ((!trouve)&&(cpt<nbClients))
  {
    trouve=(table_serveurs[table_num_serveurs[cpt]]->getNomJoueur()==nom);
    cpt++;
  }
  return trouve ? table_serveurs[table_num_serveurs[cpt-1]] : NULL;
}

void ServeurPublic::setEnCours(bool joue)
{
  enCours=joue;
}

bool ServeurPublic::getEnCours()
{
  return enCours;
}

void ServeurPublic::incJoueursPrets()
{
  joueursPrets++;
}

void ServeurPublic::decJoueursPrets()
{
  joueursPrets--;
  if (joueursPrets<=1)
  {
    bool trouve=false;
    int cpt=0;
    while ((!trouve)&&(cpt<nbClients))
    {
      trouve=(table_serveurs[table_num_serveurs[cpt]]->isPret());
      cpt++;
    }
    cpt--;
    if (trouve) envoyerATous("||||| "+table_serveurs[table_num_serveurs[cpt]]->getNomJoueur()+" a gagn !");
    else envoyerATous("La partie est termine");
    enCours=false;
    envoyerATous("fin");
  }
}

void ServeurPublic::incOntJoues()
{
  ontJoues++;
  if (ontJoues>=joueursPrets)
  {
    envoyerATous("Tour de jeu termin");
    string finTour;
    for (int cpt=0; cpt<nbClients; cpt++)
    {
      finTour+=table_serveurs[table_num_serveurs[cpt]]->getCasesJouees();
      affiche("Fin Tour:"+finTour);
    }
    envoyerATous(finTour);
    for (int cpt=0; cpt<nbClients; cpt++)
      table_serveurs[table_num_serveurs[cpt]]->resetAJoue();
    ontJoues=0;
  }
}

string ServeurPublic::getListeJoueurs()
{
  string temp="Liste des joueurs: ";
  for (int cpt=0; cpt<nbClients; cpt++)
    temp+=(table_serveurs[table_num_serveurs[cpt]]->getNomJoueur())+" - ";
  return temp;
}

void ServeurPublic::demarre()
{
  affiche("Dbut serveur bataille navale");
  //Cration boite publique
  Sock BRServeur(SOCK_STREAM,short(24118));
  desc_public = BRServeur.getsDesc();
  desc_console = 0; //entre standard
  mini=desc_console;
  maxi=desc_public;

  //Initialisation de la sauvegarde du systme SELECT
  FD_ZERO(&table_desc_backup);
  FD_SET(desc_console,&table_desc_backup);
  FD_SET(desc_public,&table_desc_backup);

  //Initialisation de la boite publique avec file d'attente
  if (listen(desc_public,10)==-1) affiche("Problme d'coute");
  else affiche("En attente de client");

  while(ok)
  {
    //Rinitialisation du systme SELECT
    FD_ZERO(&table_desc_read);
    FD_ZERO(&table_desc_except);
    ok=false;

    for(int cpt=mini; cpt<=maxi; cpt++) //initialise les table_desc
      if (FD_ISSET(cpt,&table_desc_backup))
      {
        FD_SET(cpt,&table_desc_read);
        FD_SET(cpt,&table_desc_except);
        ok=true;
      }

    select(maxi+1,&table_desc_read,NULL,&table_desc_except,NULL); //bloquant

    int num_desc_actif=mini;
    while((!FD_ISSET(num_desc_actif,&table_desc_read)) && (num_desc_actif<=maxi)) num_desc_actif++; //cherche la boite qui a reu un message

    if (num_desc_actif>maxi) //exception
    {
      num_desc_actif=mini;
      while(!FD_ISSET(num_desc_actif,&table_desc_except) && (num_desc_actif<=maxi)) num_desc_actif++; //cherche la boite qui a dclanch une exception
      affiche("erreur reue sur "+intToStr(num_desc_actif));
      table_serveurs[num_desc_actif]->exceptionRecue();
    }
    else if (num_desc_actif==desc_public) //un nouveau client arrive
    {
      affiche("nouveau client");
      int accepte = accept(desc_public,(sockaddr*)&adCV, &tailleCV);
      if (accepte<=0) affiche("Erreur de connection");
      else affiche("Connection accepte "+intToStr(accepte));

      int reception = recv(num_desc_actif,&tamponrcp,sizeof(tamponrcp),0); //pour vider le tampon
      //if (reception==-1) ;
      nouveauClient(accepte);
      if (enCours)
      {
        table_serveurs[accepte]->envoyerMessage("Partie en cours");
        //supprimeClient(accepte,true);
      }
    }
    else if (num_desc_actif==desc_console) //saisie au clavier
    {
      cin>>tamponrcp;
      if (strcmp(tamponrcp,"0")==0)
      {
        arrete("Arrt par l'administrateur de bataille");
        sleep(1);
      }
      else affiche("saisie au clavier "+charToStr(tamponrcp));
    }
    else  //Message normal
    {
      table_serveurs[num_desc_actif]->messageRecu();
    }
  }
  arrete("Au revoir");
}
