//ServeurPublic.h

#ifndef SERVEURPUBLIC_H
#define SERVEURPUBLIC_H

#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>  //struct in_addr et sockaddr_in
#include <unistd.h>
#include <string>

class ServeurPrive; //dclaration avance

class ServeurPublic
{
 private:
  int desc_public;
  int desc_console;
  char tamponrcp[256];
  char tamponenv[256];
  sockaddr_in adCV;
  socklen_t tailleCV;
  int maxi;
  int mini;
  int nbClients;
  int joueursPrets;
  int ontJoues;
  bool ok;
  bool enCours;
  ServeurPrive * table_serveurs[256];
  int table_num_serveurs[256];
 protected:
  fd_set table_desc_read;
  fd_set table_desc_except;
  fd_set table_desc_backup; //sauvegarde des ports que l'on veut couter
 public:
  ServeurPublic();
  ~ServeurPublic();
  void demarre();
  void arrete(string texte);
  void nouveauClient(int numClient);
  void supprimeClient(int numClient, bool envoiMessage);
  void envoyerATous(string texte);
  ServeurPrive * envoyerAJoueur(string nom, string texte);
  void setEnCours(bool joue);
  bool getEnCours();
  string getJoueursPrets();
  void incJoueursPrets();
  void decJoueursPrets();
  void incOntJoues();
  void affiche(char * texte);
  void affiche(string texte);
  string getListeJoueurs();
  ServeurPrive * getJoueur(string nom);
};
#endif
